# TODO
# - use system openssl instead of boringssl
# - use system nanopb package
#
# Conditional build:
%bcond_without	tests		# build without tests

%define		php_name	php%{?php_suffix}
%define		modname	grpc
Summary:	A high performance, general RPC framework that puts mobile and HTTP/2 first
Name:		%{php_name}-pecl-%{modname}
Version:        1.54.0
Release:	2
License:	BSD
Group:		Development/Languages/PHP
Source0:	http://pecl.php.net/get/%{modname}-%{version}.tgz
# Source0-md5:	8c1912166e74799f2905fc1897e418b5
Patch0:		x32.patch
URL:		http://pecl.php.net/package/grpc/
%{?with_tests:BuildRequires:    %{php_name}-cli}
BuildRequires:	%{php_name}-devel >= 4:5.5
BuildRequires:	rpmbuild(macros) >= 1.666
%if %{with tests}
BuildRequires:	%{php_name}-cli
BuildRequires:	%{php_name}-pcre
BuildRequires:	%{php_name}-spl
%endif
%{?requires_php_extension}
Provides:	php(grpc) = %{version}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Remote Procedure Calls (RPCs) provide a useful abstraction for
building distributed applications and services. The libraries in this
repository provide a concrete implementation of the gRPC protocol,
layered over HTTP/2. These libraries enable communication between
clients and servers using any combination of the supported languages.

%prep
%setup -qc
%{__mv} %{modname}-%{version}/* .
%patch0 -p1

%build
phpize
%configure
%{__make}

%if %{with tests}
# simple module load test
%{__php} -n -q \
	-d extension_dir=modules \
	-d extension=%{modname}.so \
	-m > modules.log
grep %{modname} modules.log

export NO_INTERACTION=1 REPORT_EXIT_STATUS=1 MALLOC_CHECK_=2
%{__make} test \
	PHP_EXECUTABLE=%{__php} \
	PHP_TEST_SHARED_SYSTEM_EXTENSIONS="pcre spl"
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	EXTENSION_DIR=%{php_extensiondir} \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d
cat <<'EOF' > $RPM_BUILD_ROOT%{php_sysconfdir}/conf.d/%{modname}.ini
; Enable %{modname} extension module
extension=%{modname}.so
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
%php_webserver_restart

%postun
if [ "$1" = 0 ]; then
	%php_webserver_restart
fi

%files
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) %{php_sysconfdir}/conf.d/%{modname}.ini
%attr(755,root,root) %{php_extensiondir}/%{modname}.so
%changelog
* Sun Jun 11 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/php-pecl-grpc.git;a=log;h=auto/th/php-pecl-grpc-1.54.0-2

* Sun Jun 11 2023 Jan Rękorajski <baggins@pld-linux.org> d86c65f
- rel 2

* Sun Jun 11 2023 Jan Rękorajski <baggins@pld-linux.org> 83f1eb4
- fix building on x32

* Tue May 16 2023 Arkadiusz Miśkiewicz <arekm@maven.pl> 8fa5d24
- Up to 1.54.0

* Thu Jul 21 2016 Elan Ruusamäe <glen@delfi.ee> 54b3880
- spl requires pcre on non-x86_64 platforms

* Thu Jul 21 2016 Elan Ruusamäe <glen@delfi.ee> ce6ce55
- fix includes path to avoid hack

* Wed Jul 20 2016 Elan Ruusamäe <glen@delfi.ee> 3c3ee27
- EXTRA_INCLUDES hack due misdetected include paths

* Wed Jul 20 2016 Elan Ruusamäe <glen@delfi.ee> 29d530d
- new, version 0.15.0

